#!/usr/bin/env python3

from cryptography.hazmat.backends import default_backend
from cryptography.hazmat.primitives import serialization

from cryptography.hazmat.primitives import hashes
from cryptography.hazmat.primitives.asymmetric import padding

'''
def load_private_key(private_key_file):
    key_file = open(private_key_file, 'rb')
    key_data = key_file.read()
    key_file.close()

    key = serialization.load_pem_private_key(
        key_data,
        password=None,
        backend=default_backend()
    )
    return key


def load_public_key(public_key_file):
    key_file = open(public_key_file, 'rb')
    key_data = key_file.read()
    key_file.close()

    key = serialization.load_pem_public_key(
        key_data,
        backend=default_backend()
    )

    return key
'''


def sign(data_file_name, signature_file_name, private_key_file_name):
    """
    :param data_file_name:
    :param signature_file_name:
    :param private_key_file_name:
    :return:
    """
    # read data
    data_file = open(data_file_name, 'rb')
    data = data_file.read()
    data_file.close()

    # read private key file
    key_file = open(private_key_file_name, 'rb')
    key_data = key_file.read()
    key_file.close()

    # load private key
    private_key = serialization.load_pem_private_key(
        key_data,
        password=None,
        backend=default_backend()
    )

    # sign sha256 hash with private key
    signature = private_key.sign(
        data,
        padding.PKCS1v15(),
        hashes.SHA256()
    )

    # write signature
    signature_file = open(signature_file_name, 'wb')
    signature_file.write(signature)
    signature_file.close()

    return signature


if __name__ == '__main__':
    data_file = r'data.bin'
    signature_file = r'signature.bin'
    private_key_file = r'Key.pem'

    signature = sign(data_file, signature_file, private_key_file)
    [print('%02x' % x, end='') for x in signature]
